diff -r 82fcd4bea972 src/mn.c
--- a/src/mn.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mn.c	Fri Jan 11 17:02:25 2008 +0100
@@ -1321,6 +1680,220 @@ static int flag_hoa(struct ifaddrmsg *if
 	return 0;
 }
 
+static int mcoa_iface_dflt_hoa_rule_del(struct bulentry *bule, 
+	 				struct bulentry *best_bule,
+					struct home_addr_info *hai,
+					int replace)
+{
+	/* MCoA: Delete the default HoA rule */
+	rule_del(NULL, bule->bid, IP6_RULE_PRIO_MIP6_HOA_OUT, 
+		0, RTN_UNICAST, &hai->hoa.addr, 128,
+		&in6addr_any, 0, FIB_RULE_FIND_SADDR);
+	
+	/* MCoA
+	 * Do not replace the default rules 
+	 * if there are no other best bule 
+ 	 */
+	if(best_bule && best_bule != bule && replace) {
+		if (rule_add(NULL, best_bule->bid, 
+			IP6_RULE_PRIO_MIP6_HOA_OUT, 0, RTN_UNICAST, 
+			&hai->hoa.addr, 128, &in6addr_any, 0, 
+			FIB_RULE_FIND_SADDR) < 0)
+		return -1;
+	}
+	return 0;
+}
+
+static void mcoa_iface_dflt_mnp_rules_del(struct bulentry *bule, 
+					  struct bulentry *best_bule,
+					  struct home_addr_info *hai,
+					  struct prefix_list_entry *p,
+					  int replace)
+{
+	/* MCoA: Delete the default MNP rule */
+	rule_del(NULL, bule->bid, IP6_RULE_PRIO_MIP6_FWD_MCOA, 
+		0, RTN_UNICAST, &p->ple_prefix, p->ple_plen, 
+		&in6addr_any, 0, 0);
+
+	/* MCoA
+	 * Do not replace the default rules 
+	 * if there are no other best bule 
+	 */
+	if(best_bule && best_bule != bule && replace) {
+		rule_add(NULL, best_bule->bid, 
+			IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, RTN_UNICAST, 
+			&p->ple_prefix, p->ple_plen, &in6addr_any, 0, 0);
+	}
+}
+ 
+static struct bulentry* mcoa_iface_rules_del(int iif, 
+					     struct home_addr_info *hai,
+					     int replace)
+{
+	uint16_t bid = hai->reg_mcoa?get_bid_from_ifindex(iif):MCOA_NO_BID;
+	uint8_t prio_tmp = 0;
+	struct bulentry *bule, *best_bule = NULL;
+	struct list_head *l;
+	int delete_dflt_mnp = 0;
+
+	bule = bul_get(hai,  NULL, &hai->ha_addr, bid);
+	if (!hai->reg_mcoa || (bule && !bule->rules))
+		return NULL;
+
+	/* MCoA: Delete rule for HoA traffic from the MN */
+	rule_del(NULL, bid, IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA, 
+		/* fwmark */ bid, RTN_UNICAST,
+	     	&hai->hoa.addr, 128, &in6addr_any, 0, 
+		FIB_RULE_FIND_SADDR);
+
+	bul_iterate_in(&hai->ha_addr, bul_highest_priority, 
+			&best_bule);
+	if(bule && best_bule == bule) {
+		delete_dflt_mnp = 1;
+		/* MCoA: search for the next best BULE */
+		prio_tmp = bule->priority;
+		bule->priority = 0;
+		bul_iterate_in(&hai->ha_addr, 
+				bul_highest_priority, &best_bule);
+		bule->priority = prio_tmp;
+		/* MCoA: delete the default HoA rule */
+		mcoa_iface_dflt_hoa_rule_del(bule, best_bule, hai, replace);
+	} 
+
+	list_for_each(l, &hai->mob_net_prefixes) {
+		struct prefix_list_entry *p = NULL;
+		p = list_entry(l, struct prefix_list_entry, list);
+		/* MCoA: Delete MNP rule */
+		rule_del(NULL, bid, IP6_RULE_PRIO_MIP6_FWD_FWM, 
+			/*fwmark*/ bid, RTN_UNICAST, &p->ple_prefix, 
+			p->ple_plen, &in6addr_any, 0, 0);
+		if(delete_dflt_mnp) {
+			/* MCoA: Delete default MNP rule */
+			mcoa_iface_dflt_mnp_rules_del(bule, best_bule, 
+						hai, p, replace);
+		}
+ 	}
+	
+	if (bule) {
+		bule->rules = 0;
+		MDBG("MNP and HoA rules deleted for iface %d bid %d\n", 
+			iif, bule->bid);
+	}
+	
+	return bule;
+}
+ 
+static void mcoa_mn_rules_del(struct home_addr_info *hinfo)
+{
+	struct list_head *l;
+ 
+	list_for_each(l, &hinfo->mcoa) {
+		struct mn_addr *iface = NULL;
+		iface = list_entry(l, struct mn_addr, list);
+		mcoa_iface_rules_del(iface->iif, hinfo, 0);
+	}
+	rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_HOA_OUT, 
+		0, RTN_UNICAST, &hinfo->hoa.addr, 128, 
+		&in6addr_any, 0, FIB_RULE_FIND_SADDR);
+	if (hinfo->at_home && hinfo->reg_mcoa) {
+		list_for_each(l, &hinfo->mob_net_prefixes) {
+			struct prefix_list_entry *p = NULL;
+			p = list_entry(l, struct prefix_list_entry, 
+					list);
+			rule_del(NULL, RT6_TABLE_MIP6,
+				IP6_RULE_PRIO_MIP6_FWD, 0, 
+				RTN_UNICAST, &p->ple_prefix, 
+				p->ple_plen, &in6addr_any, 0, 0);
+		}
+	}
+}
+	
+static int mcoa_iface_rules_add(int iif, struct home_addr_info *hai)
+{
+	uint16_t bid = hai->reg_mcoa?get_bid_from_ifindex(iif):MCOA_NO_BID;
+	struct bulentry *bule, *best_bule = NULL;
+	struct prefix_list_entry *pe = NULL;
+	struct list_head *l;
+	uint8_t prio;
+ 
+	bule = bul_get(hai, NULL, &hai->ha_addr, bid);
+	if (!bid || !hai->reg_mcoa || !bule || (bule && bule->rules))
+		return 0;
+
+	prio = get_prio_from_bid(bid);
+	
+	/* MCoA: Rule for HoA traffic from the MN */
+	if (rule_add(NULL, bid, IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA, 
+			/* fwmark */ bid, RTN_UNICAST,
+	 		&hai->hoa.addr, 128, &in6addr_any, 0, 
+			FIB_RULE_FIND_SADDR) < 0)
+		goto undo;
+	
+	bul_iterate_in(&hai->ha_addr, bul_highest_priority, 
+			&best_bule);
+	
+	if (!best_bule || prio >= best_bule->priority) { 
+		rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_HOA_OUT, 
+				0, RTN_UNICAST, &hai->hoa.addr, 128, 
+				&in6addr_any, 0, FIB_RULE_FIND_SADDR);
+		if (rule_add(NULL, bid, IP6_RULE_PRIO_MIP6_HOA_OUT, 
+				0, RTN_UNICAST, &hai->hoa.addr, 128, 
+				&in6addr_any, 0, FIB_RULE_FIND_SADDR) < 0)
+			goto undo;
+	}
+
+	/* MCoA: Rule for forwarded traffic from the NEMO */
+	list_for_each(l, &hai->mob_net_prefixes) {
+		struct prefix_list_entry *p = NULL;
+		p = list_entry(l, struct prefix_list_entry, list);
+		if (rule_add(NULL, bid, IP6_RULE_PRIO_MIP6_FWD_FWM, 
+				/*fwmark*/ bid, RTN_UNICAST, 
+				&p->ple_prefix, p->ple_plen, 
+				&in6addr_any, 0, 0) < 0) {
+			pe = p;
+			goto undo;
+		}
+		/* MCoA
+		 * Add default rules if the bule has the highest 
+		 * priority
+ 	 	 */
+		if (!best_bule || prio >= best_bule->priority) { 
+			rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 
+				0, RTN_UNICAST, &p->ple_prefix, p->ple_plen, 
+				&in6addr_any, 0, 0);
+			if (rule_add(NULL, bid, IP6_RULE_PRIO_MIP6_FWD_MCOA, 
+				0, RTN_UNICAST, &p->ple_prefix, p->ple_plen, 
+				&in6addr_any, 0, 0) < 0)
+				goto undo;
+		}
+	}
+	
+	bule->rules = 1;
+	MDBG("MNP and HoA Rules added for interface %d.\n", iif);
+ 	return 0;
+
+undo:
+	rule_del(NULL, bid, IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA, 
+		/* fwmark */ bid, RTN_UNICAST,
+		&hai->hoa.addr, 128, &in6addr_any, 0, 
+		FIB_RULE_FIND_SADDR);
+
+	rule_del(NULL, bid, IP6_RULE_PRIO_MIP6_HOA_OUT, 
+		0, RTN_UNICAST, &hai->hoa.addr, 128, 
+		&in6addr_any, 0, FIB_RULE_FIND_SADDR);
+		
+	list_for_each(l, &hai->mob_net_prefixes) {
+		struct prefix_list_entry *p = NULL;
+		p = list_entry(l, struct prefix_list_entry, list);
+		rule_del(NULL, bid, IP6_RULE_PRIO_MIP6_FWD_FWM, 
+			/*fwmark*/ bid, RTN_UNICAST, &p->ple_prefix, 
+			p->ple_plen, &in6addr_any, 0, 0);
+		if (p == pe)
+			break;
+	}
+	return -1;
+}
+
 static void nemo_mr_rules_del(struct home_addr_info *hinfo)
 {
 	struct list_head *l;
@@ -1328,11 +1901,17 @@ static void nemo_mr_rules_del(struct hom
 	list_for_each(l, &hinfo->mob_net_prefixes) {
 		struct prefix_list_entry *p = NULL;
 		p = list_entry(l, struct prefix_list_entry, list);
-		rule_del(NULL, RT6_TABLE_MIP6,
-			 IP6_RULE_PRIO_MIP6_FWD, RTN_UNICAST,
-			 &p->ple_prefix, p->ple_plen, &in6addr_any, 0, 0);
+		if (hinfo->reg_mcoa) {
+			rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+				RTN_UNICAST, &p->ple_prefix, p->ple_plen, 
+				&in6addr_any, 0, 0);
+		} else
+			rule_del(NULL, RT6_TABLE_MIP6,
+				IP6_RULE_PRIO_MIP6_FWD, 0, RTN_UNICAST,
+			 	&p->ple_prefix, p->ple_plen, &in6addr_any, 
+				0, 0);
 		rule_del(NULL, RT6_TABLE_MAIN,
-			 IP6_RULE_PRIO_MIP6_MNP_IN, RTN_UNICAST,
+			 IP6_RULE_PRIO_MIP6_MNP_IN, 0, RTN_UNICAST,
 			 &in6addr_any, 0, &p->ple_prefix, p->ple_plen, 0);
 	}
 }
@@ -1346,19 +1925,21 @@ static int nemo_mr_rules_add(struct home
 		struct prefix_list_entry *p = NULL;
 		p = list_entry(l, struct prefix_list_entry, list);
 		if (rule_add(NULL, RT6_TABLE_MAIN,
-			     IP6_RULE_PRIO_MIP6_MNP_IN, RTN_UNICAST,
+			     IP6_RULE_PRIO_MIP6_MNP_IN, 0, RTN_UNICAST,
 			     &in6addr_any, 0,
 			     &p->ple_prefix, p->ple_plen, 0) < 0) {
 			pe = p;
 			goto undo;
 		}
-		if (rule_add(NULL, RT6_TABLE_MIP6,
-			     IP6_RULE_PRIO_MIP6_FWD, RTN_UNICAST,
-			     &p->ple_prefix, p->ple_plen,
-			     &in6addr_any, 0, 0) < 0) {
+		if (!hinfo->reg_mcoa 
+		    && rule_add(NULL, RT6_TABLE_MIP6,
+			     	IP6_RULE_PRIO_MIP6_FWD, 0, RTN_UNICAST,
+			     	&p->ple_prefix, p->ple_plen, 
+			     	&in6addr_any, 0, 0) < 0) {
 			rule_del(NULL, RT6_TABLE_MAIN,
-				 IP6_RULE_PRIO_MIP6_MNP_IN, RTN_UNICAST,
-				 &in6addr_any, 0, &p->ple_prefix, p->ple_plen, 0);
+				 IP6_RULE_PRIO_MIP6_MNP_IN, 0, 
+				 RTN_UNICAST, &in6addr_any, 0, 
+				 &p->ple_prefix, p->ple_plen, 0);
 			pe = p;
 			goto undo;
 		}
@@ -1368,17 +1949,25 @@ undo:
 	list_for_each(l, &hinfo->mob_net_prefixes) {
 		struct prefix_list_entry *p = NULL;
 		p = list_entry(l, struct prefix_list_entry, list);
-		rule_del(NULL, RT6_TABLE_MIP6,
-			 IP6_RULE_PRIO_MIP6_FWD,  RTN_UNICAST,
-			 &p->ple_prefix, p->ple_plen, &in6addr_any, 0, 0);
+		if (!hinfo->reg_mcoa) {
+			rule_del(NULL, RT6_TABLE_MIP6,
+				IP6_RULE_PRIO_MIP6_FWD, 0, RTN_UNICAST,
+				&p->ple_prefix, p->ple_plen, 
+				&in6addr_any, 0, 0);
+		}
 		rule_del(NULL, RT6_TABLE_MAIN,
-			 IP6_RULE_PRIO_MIP6_MNP_IN, RTN_UNICAST,
+			 IP6_RULE_PRIO_MIP6_MNP_IN, 0, RTN_UNICAST,
 			 &in6addr_any, 0, &p->ple_prefix, p->ple_plen, 0);
 		if (p == pe)
 			break;
 	}
 	return -1;
 }
+
+struct mcoa_tnl_id {
+	struct list_head list;
+	int tnl_id;
+};
 
 static void clean_home_addr_info(struct home_addr_info *hai)
 {
@@ -1390,17 +1979,24 @@ static void clean_home_addr_info(struct 
 		nemo_mr_rules_del(hai);
 	arg.target = hai;
 	arg.flag = 0;
-	addr_do(&hai->hoa.addr, plen,
-		hai->hoa.iif, &arg, flag_hoa);
+	/* MCoA: Flag HoA on the tunnel iface is not necessary here */
+	if (!hai->reg_mcoa)
+		addr_do(&hai->hoa.addr, plen,
+			hai->hoa.iif, &arg, flag_hoa);
 	bul_iterate(&hai->bul, mn_dereg, NULL);
-	bul_home_cleanup(&hai->bul);
-
+	/* MCoA: Delete all mn rules */
+	if (hai->reg_mcoa)
+		mcoa_mn_rules_del(hai);
 	mn_block_rule_del(hai);
 
-	rule_del(NULL, RT6_TABLE_MIP6,
-		 IP6_RULE_PRIO_MIP6_HOA_OUT, RTN_UNICAST,
-		 &hai->hoa.addr, 128, &in6addr_any, 0, FIB_RULE_FIND_SADDR);
-	tunnel_del(hai->if_tunnel, NULL, NULL);
+	if (!hai->reg_mcoa) {	
+		rule_del(NULL, RT6_TABLE_MIP6,
+			 IP6_RULE_PRIO_MIP6_HOA_OUT, 0, RTN_UNICAST,
+			 &hai->hoa.addr, 128, &in6addr_any, 0, 
+			 FIB_RULE_FIND_SADDR);
+		tunnel_del(hai->if_tunnel, NULL, NULL);
+	}
+	bul_home_cleanup(&hai->bul);
 	dhaad_stop(hai);
 	free(hai);
 }	
@@ -1448,6 +2044,11 @@ static struct home_addr_info *hai_copy(s
 				     &hai->mob_net_prefixes) < 0)
 			goto mutex_undo;
 
+		INIT_LIST_HEAD(&hai->mcoa);
+		if (hai->reg_mcoa && 
+		    prefix_list_copy(&conf_hai->mcoa, &hai->mcoa) < 0)
+			goto mutex_undo;
+
 		INIT_LIST_HEAD(&hai->ro_policies);
 		if (rpl_copy(&conf_hai->ro_policies, &hai->ro_policies) < 0)
 			goto mnp_undo;
@@ -1493,17 +2094,22 @@ static int conf_home_addr_info(struct ho
 		MDBG("HA address %x:%x:%x:%x:%x:%x:%x:%x\n", 
 		     NIP6ADDR(&hai->ha_addr)); 
 	}
-	hai->if_tunnel = tunnel_add(&hai->hoa.addr, &hai->ha_addr,
-				    hai->if_home, NULL, NULL);
+	/* MCoA: tunnel is created only if MCoA registration is not used */
+	if(!hai->reg_mcoa) {
+		hai->if_tunnel = tunnel_add(&hai->hoa.addr, 
+					&hai->ha_addr,
+					hai->if_home, NULL, NULL);
 
-	if (hai->if_tunnel <= 0) {
-		MDBG("failed to create MN-HA tunnel\n"); 
-		goto clean_err;
-	}
-	if (rule_add(NULL, RT6_TABLE_MIP6,
-		     IP6_RULE_PRIO_MIP6_HOA_OUT, RTN_UNICAST,
-		     &hai->hoa.addr, 128, &in6addr_any, 0, FIB_RULE_FIND_SADDR) < 0) {
-		goto clean_err;
+		if (hai->if_tunnel <= 0) {
+			MDBG("failed to create MN-HA tunnel\n"); 
+			goto clean_err;
+		}
+		if (rule_add(NULL, RT6_TABLE_MIP6, 
+			     IP6_RULE_PRIO_MIP6_HOA_OUT, 0, RTN_UNICAST, 
+			     &hai->hoa.addr, 128, &in6addr_any, 0, 
+			     FIB_RULE_FIND_SADDR) < 0) {
+			goto clean_err;
+		}
 	}
 
 	if (mn_block_rule_add(hai) < 0)
@@ -1524,16 +2130,25 @@ static int conf_home_addr_info(struct ho
 			       PREFIX_LIFETIME_INFINITE,
 			       PREFIX_LIFETIME_INFINITE);
 
-	arg.target = hai;
-	arg.flag = 1;
+	/* MCoA */
+	if(!hai->reg_mcoa) {
+		arg.target = hai;
+		arg.flag = 1;
 
-	if (addr_do(&hai->hoa.addr, 128,
-		    hai->if_tunnel, &arg, flag_hoa) < 0) {
-		goto clean_err;
+		if (addr_do(&hai->hoa.addr, 128,
+			    hai->if_tunnel, &arg, flag_hoa) < 0) {
+			goto clean_err;
+		}
 	}
 	if (hai->mob_rtr && nemo_mr_rules_add(hai) < 0) {
 		goto clean_err;
 	}
+	/* MCoA TODO1
+	 * For Home-CoA support, hai->at_home must be initialized to 0
+	 * if(hai->reg_mcoa) hai->at_home = 0; 
+	 * BUT Home-CoA solution seems to be deprecated by the no-NDP 
+	 * solution
+	 */
 	hai->at_home = hai->hoa.iif == hai->if_home;
 	pthread_rwlock_wrlock(&mn_lock);
 	list_add(&hai->list, &home_addr_list);
@@ -1635,7 +2250,11 @@ int mn_update_home_prefix(struct home_ad
 	if (!hai->at_home) {
 		struct bulentry *e;
 		
-		e = bul_get(hai,  NULL, &hai->ha_addr);
+		/* MCoA TODO1
+		 * Do the same for all entries that match &hai->ha_addr 
+		 */
+		e = bul_get(hai, NULL, &hai->ha_addr, MCOA_NO_BID);
+
 		if (e == NULL || !(e->flags & IP6_MH_BU_HOME))
 			return -ENOENT;
 		
@@ -1668,8 +2287,9 @@ static int mn_get_ro_coa(const struct in
 		return ret;
 	hai = mn_get_home_addr(hoa);
 	if (hai) {
-		*coa = hai->primary_coa.addr;
-		ret = hai->primary_coa.iif;
+		assert(hai->current_coa);
+		*coa = hai->current_coa->addr;
+		ret = hai->current_coa->iif;
 	} else {
 		MDBG("Failed to find a home address info\n");
 		ret = -1;
@@ -1683,14 +2303,14 @@ static inline void linklocal_rt_rules_de
 static inline void linklocal_rt_rules_del(void)
 {
 	rule_del(NULL, RT6_TABLE_MAIN,
-		 IP6_RULE_PRIO_MIP6_COA_OUT, RTN_UNICAST,
+		 IP6_RULE_PRIO_MIP6_COA_OUT, 0, RTN_UNICAST,
 		 &linklocal_prefix, 64, &in6addr_any, 0, 0);
 }
 
 static inline int linklocal_rt_rules_add(void)
 {
 	return rule_add(NULL, RT6_TABLE_MAIN,
-			IP6_RULE_PRIO_MIP6_COA_OUT, RTN_UNICAST,
+			IP6_RULE_PRIO_MIP6_COA_OUT, 0, RTN_UNICAST,
 			&linklocal_prefix, 64, &in6addr_any, 0, 0);
 }
 
@@ -1705,12 +2325,13 @@ static int mn_ext_tunnel_ops(int request
 	mha.if_next = new_if;
 	mha.target = hai;
 
+	/* MCoA: Update state for the correct table (hai->table) */	
 	if (hai->hoa.iif == old_if &&
-	    (mn_tnl_state_add(hai, new_if, 1) ||
+	    (mn_tnl_state_add(hai, new_if, 1, hai->table) ||	     
 	     addr_do(&hai->hoa.addr, 128, old_if, &mha, mv_hoa) < 0))
 		goto undo;
 
-	mn_tnl_state_del(hai, old_if, 1);
+	mn_tnl_state_del(hai, old_if, 1, hai->table);
 	hai->if_tunnel = new_if;
 	return 0;
 undo:
@@ -1718,28 +2339,52 @@ undo:
 
 	if (hai->hoa.iif == new_if)
 		addr_do(&hai->hoa.addr, 128, new_if, &mha, mv_hoa); 
-	mn_tnl_state_del(hai, new_if, 1);
+	mn_tnl_state_del(hai, new_if, 1, hai->table);
 	return -1;
 }
 
 static int mn_move(struct home_addr_info *hai)
 {
 	struct mv_hoa_args mha;
+	struct list_head *l;
 
 	mha.target = hai;
 
 	TRACE;
+	assert(hai->current_coa);
 
 	if (hai->at_home) {
 		int plen = (hai->hoa.iif == hai->if_tunnel ? 128 : hai->plen);
 		struct bulentry *e;
 		MDBG("in home net\n");
+		/* MCoA 
+		 * If we are in the home network, add a rule to
+		 * RT6_TABLE_MIP6 to allow routing of the packets from 
+		 * the MNNs (routes in RT6_TABLE_MIP6 are 
+		 * added/deleted in movement.c/md_update_router_stats,
+		 * __md_free_router) and the MR.
+		 */
+		if (hai->reg_mcoa) {
+			list_for_each(l, &hai->mob_net_prefixes) {
+				struct prefix_list_entry *p = NULL;
+				p = list_entry(l, struct prefix_list_entry, 
+						list);
+				rule_add(NULL, RT6_TABLE_MIP6,
+			     		IP6_RULE_PRIO_MIP6_FWD, 0, 
+					RTN_UNICAST, &p->ple_prefix, 
+					p->ple_plen, &in6addr_any, 0, 0);
+			}
+		}
 		if (hai->home_reg_status == HOME_REG_NONE &&
-		    (e = bul_get(hai,  NULL, &hai->ha_addr)) != NULL &&
+		    (e = bul_get(hai, NULL, &hai->ha_addr, 
+				 hai->reg_mcoa?
+				 get_bid_from_ifindex(hai->current_coa->iif)
+				 :MCOA_NO_BID)) 
+		    		 != NULL &&
 		    e->flags & IP6_MH_BU_HOME && e->type != BUL_ENTRY)
 			bul_delete(e);
-		if (hai->hoa.iif != hai->primary_coa.iif) {
-			mha.if_next = hai->primary_coa.iif;
+		if (hai->hoa.iif != hai->current_coa->iif) {
+			mha.if_next = hai->current_coa->iif;
 			addr_do(&hai->hoa.addr, plen,
 				hai->hoa.iif, &mha, mv_hoa);
 			if (hai->home_reg_status == HOME_REG_NONE) {
@@ -1760,10 +2405,33 @@ static int mn_move(struct home_addr_info
 			hai->pend_ba = 0;
 			pending_bas--;
 		}
+		/* MCoA
+		 * When in a foreign network, delete the 
+		 * rules to RT6_TABLE_MIP6
+		 */
+		if (hai->reg_mcoa) {
+			list_for_each(l, &hai->mob_net_prefixes) {
+				struct prefix_list_entry *p = NULL;
+				p = list_entry(l, struct prefix_list_entry, 
+						list);
+				rule_del(NULL, RT6_TABLE_MIP6,
+					IP6_RULE_PRIO_MIP6_FWD, 0, 
+					RTN_UNICAST, &p->ple_prefix, 
+					p->ple_plen, &in6addr_any, 0, 0);
+			}
+		}
 		if (hai->hoa.iif != hai->if_tunnel) {
 			mha.if_next = hai->if_tunnel;
-			addr_do(&hai->hoa.addr, hai->plen,
-				hai->hoa.iif, &mha, mv_hoa);
+			/* MCoA 
+			 * HoA is moved if we do not use MCoA,
+			 * HoA is copied if we use MCoA
+			 */
+			if (hai->reg_mcoa)
+				addr_do(&hai->hoa.addr, hai->plen,
+					hai->hoa.iif, &mha, cp_hoa);
+			else
+				addr_do(&hai->hoa.addr, hai->plen,
+					hai->hoa.iif, &mha, mv_hoa);
 		}
 		do_handoff(hai);
 	}
@@ -1951,6 +2619,7 @@ static int mn_do_dad(struct home_addr_in
 	struct in6_addr solicit;
 	int type = FLUSH_ALL;
 
+	assert(hai->current_coa);	
 	if ((sock = socket(AF_INET6, SOCK_RAW, IPPROTO_ICMPV6)) < 0)
 		return ret;
 
@@ -1963,22 +2632,22 @@ static int mn_do_dad(struct home_addr_in
 		   sizeof(struct icmp6_filter));
 
 	ipv6_addr_solict_mult(&hai->hoa.addr, &solicit);
-	if_mc_group(sock, hai->primary_coa.iif, &in6addr_all_nodes_mc, 
+	if_mc_group(sock, hai->current_coa->iif, &in6addr_all_nodes_mc, 
 		    IPV6_JOIN_GROUP);
-	if_mc_group(sock, hai->primary_coa.iif, &solicit, IPV6_JOIN_GROUP);
+	if_mc_group(sock, hai->current_coa->iif, &solicit, IPV6_JOIN_GROUP);
 
 	if (hai->home_reg_status == HOME_REG_NONE) {
 		if (hai->lladdr_comp) {
 			struct in6_addr lladdr;
 			ipv6_addr_llocal(&hai->hoa.addr, &lladdr);
 			if (mn_addr_do_dad(sock, NULL, &lladdr, 64, 
-					   hai->primary_coa.iif, 0) < 0) {
+					   hai->current_coa->iif, 0) < 0) {
 				MDBG("Link-local DAD failed!\n");
 				goto err;
 			}
 		}
 		if (mn_addr_do_dad(sock, hai, &hai->hoa.addr, hai->plen, 
-				   hai->primary_coa.iif, 0) < 0) {
+				   hai->current_coa->iif, 0) < 0) {
 			MDBG("HoA DAD failed!\n");
 			goto err;
 		}
@@ -1986,7 +2655,7 @@ static int mn_do_dad(struct home_addr_in
 			mn_send_home_na(hai);
 		ret = mn_move(hai);
 	} else if (!mn_addr_do_dad(sock, hai, &hai->hoa.addr, 
-				   hai->plen, hai->primary_coa.iif, 1)) {
+				   hai->plen, hai->current_coa->iif, 1)) {
 		ret = mn_move(hai);
 	}
 out:
@@ -2009,15 +2678,19 @@ static inline void mn_update_coa_lifetim
 
 static void mn_coa_updated(struct home_addr_info *hai)
 {
+	assert(hai->current_coa);
 	if (!hai->at_home) {
 		struct bulentry *e;
 		struct mn_addr *coa;
 		
-		e = bul_get(hai, NULL, &hai->ha_addr);
+		e = bul_get(hai, NULL, &hai->ha_addr, 
+			    hai->reg_mcoa?
+			    get_bid_from_ifindex(hai->current_coa->iif)
+			    :MCOA_NO_BID);
 		if (e == NULL || !(e->flags & IP6_MH_BU_HOME))
 			return;
 		
-		coa = &hai->primary_coa;
+		coa = hai->current_coa;
 		
 		MDBG2("preferred_time %u valid_life %u\n",
 		      coa->preferred_time.tv_sec,
@@ -2075,6 +2748,10 @@ static struct md_inet6_iface *mn_get_ifa
 	list_for_each(l, iface_list) {
 		struct md_inet6_iface *iface;
 		iface = list_entry(l, struct md_inet6_iface, list);
+		/* MCoA TODO1
+		 * If MCoA is used, MCoA preference must be used instead
+		 * of interfaces preference
+		 */
 		if (mn_verify_iface(iface) &&
 		    (best_iface == NULL ||
 		     (best_iface)->preference > iface->preference ||
@@ -2119,6 +2796,106 @@ static struct md_coa *mn_get_coa(const s
 	return best_coa;
 }
 
+static int mcoa_mn_make_ho_verdict(const struct movement_event *me,
+			      const struct home_addr_info *hai, 
+			      struct md_router **next_rtr,
+			      struct md_coa **next_coa)
+{
+	/* MCoA 
+	 * The handoff algorithm is different from 
+	 * mn_make_ho_verdict because we do not perform vertical 
+	 * handover, but only horizontal handovers.
+	 */
+	struct md_router *rtr;
+	struct md_coa *coa = NULL;
+	int force = 0;
+
+	/* MCoA TODO1
+	 * For Home-CoA support, remove this if(){}
+	 * BUT Home-CoA seems to be deprecated
+	 */
+	if (me->iface != NULL && 
+	    (rtr = md_get_first_router(&me->iface->default_rtr)) != NULL &&
+	    mn_is_at_home(&rtr->prefixes, &hai->home_prefix, hai->home_plen)) {
+		*next_rtr = rtr;
+		*next_coa = NULL;
+		return MN_HO_RETURN_HOME;
+	}
+	switch (me->event_type) {
+	case ME_DHAAD:
+		force = 1;
+		break;
+	case ME_IFACE_DOWN:
+	case ME_LINK_DOWN:
+	case ME_RTR_EXPIRED:
+		break;
+	case ME_RTR_NEW:
+		assert(!list_empty(&me->iface->default_rtr));
+	case ME_LINK_UP:
+		assert(me->iface != NULL);
+		break;
+	case ME_RTR_BACK:
+	case ME_RTR_UPDATED:
+		assert(me->iface != NULL);
+		assert(!list_empty(&me->iface->default_rtr));
+
+		*next_coa = md_get_coa(&me->iface->coas,
+				       &hai->current_coa->addr);
+		if (*next_coa == NULL)
+			break;
+		*next_rtr = md_get_first_router(&me->iface->default_rtr);
+		return MN_HO_REESTABLISH;
+	case ME_COA_NEW:
+		assert(me->iface != NULL);
+		assert(me->coa != NULL);
+		assert(me->iface->ifindex == me->coa->ifindex);
+		break;
+	case ME_COA_EXPIRED:
+		assert(me->iface != NULL);
+		assert(me->coa != NULL);
+		assert(me->iface->ifindex == me->coa->ifindex);
+
+		if (IN6_ARE_ADDR_EQUAL(&hai->current_coa->addr, 
+					&me->coa->addr))
+			break;
+		return MN_HO_IGNORE;		
+	case ME_COA_LFT_DEC:
+	case ME_COA_LFT_INC:
+		assert(me->iface != NULL);
+		assert(me->coa != NULL);
+		assert(me->iface->ifindex == me->coa->ifindex);
+
+		if (!IN6_ARE_ADDR_EQUAL(&hai->current_coa->addr,
+					&me->coa->addr)) {
+			return MN_HO_IGNORE;
+		}
+
+		*next_coa = me->coa;
+		return MN_HO_CHECK_LIFETIME;
+	default:
+		return MN_HO_IGNORE;
+	}
+	if (!mn_verify_iface(me->iface))
+		return MN_HO_INVALIDATE;
+
+	coa = mn_get_coa(hai, me->iface->ifindex,
+			 &hai->current_coa->addr, &me->iface->coas);
+
+	if (coa == NULL) 
+		return MN_HO_INVALIDATE;
+
+	if (!force && 
+	    IN6_ARE_ADDR_EQUAL(&coa->addr, &hai->current_coa->addr)) 
+		return MN_HO_IGNORE;
+
+	if (list_empty(&me->iface->default_rtr)) 
+		return MN_HO_IGNORE;
+
+	*next_rtr = md_get_first_router(&me->iface->default_rtr);
+	*next_coa = coa;
+	return MN_HO_PROCEED;
+}
+
 static int mn_make_ho_verdict(const struct movement_event *me,
 			      const struct home_addr_info *hai, 
 			      struct md_router **next_rtr,
@@ -2127,9 +2904,11 @@ static int mn_make_ho_verdict(const stru
 	struct md_inet6_iface *old_iface = NULL, *new_iface = NULL;
 	struct md_router *rtr;
 	struct md_coa *coa = NULL;
-	int pref_iif = hai->primary_coa.iif; /* prefer current CoA interface */
+	int pref_iif;
 	int force = 0;
 
+	assert(hai->current_coa);
+	pref_iif = hai->current_coa->iif; /* prefer current CoA interface */
 	if (me->iface != NULL && 
 	    (rtr = md_get_first_router(&me->iface->default_rtr)) != NULL &&
 	    mn_is_at_home(&rtr->prefixes, &hai->home_prefix, hai->home_plen)) {
@@ -2170,7 +2949,7 @@ static int mn_make_ho_verdict(const stru
 			return MN_HO_IGNORE;
 
 		*next_coa = md_get_coa(&old_iface->coas,
-				       &hai->primary_coa.addr);
+				       &hai->current_coa->addr);
 		if (*next_coa == NULL)
 			break;
 		*next_rtr = md_get_first_router(&old_iface->default_rtr);
@@ -2187,7 +2966,7 @@ static int mn_make_ho_verdict(const stru
 
 		if (old_iface == NULL ||
 		    (old_iface == me->iface &&
-		     IN6_ARE_ADDR_EQUAL(&hai->primary_coa.addr, 
+		     IN6_ARE_ADDR_EQUAL(&hai->current_coa->addr, 
 					&me->coa->addr)))
 			break;
 		return MN_HO_IGNORE;		
@@ -2201,7 +2980,7 @@ static int mn_make_ho_verdict(const stru
 			break;
 
 		if (old_iface != me->iface ||
-		    !IN6_ARE_ADDR_EQUAL(&hai->primary_coa.addr,
+		    !IN6_ARE_ADDR_EQUAL(&hai->current_coa->addr,
 					&me->coa->addr))
 			return MN_HO_IGNORE;
 
@@ -2216,13 +2995,13 @@ static int mn_make_ho_verdict(const stru
 		return MN_HO_INVALIDATE;
 
 	coa = mn_get_coa(hai, new_iface->ifindex,
-			 &hai->primary_coa.addr, &new_iface->coas);
+			 &hai->current_coa->addr, &new_iface->coas);
 
 	if (coa == NULL)
 		return MN_HO_INVALIDATE;
 
 	if (!force && new_iface == old_iface && 
-	    IN6_ARE_ADDR_EQUAL(&coa->addr, &hai->primary_coa.addr))
+	    IN6_ARE_ADDR_EQUAL(&coa->addr, &hai->current_coa->addr))
 		return MN_HO_IGNORE;
 
 	if (list_empty(&new_iface->default_rtr))
@@ -2231,6 +3010,100 @@ static int mn_make_ho_verdict(const stru
 	*next_rtr = md_get_first_router(&new_iface->default_rtr);
 	*next_coa = coa;
 	return MN_HO_PROCEED;
+}
+
+static void mcoa_mn_chk_ho_verdict(struct home_addr_info *hai,
+			      const struct movement_event *event)
+{
+	struct md_router *rtr = NULL;
+	struct md_coa *coa = NULL;
+	struct bulentry *bule;
+	int move_home = 0;	
+	int active_coa = 0;
+
+	if ((bule = bul_get(hai,  NULL, &hai->ha_addr, 
+			hai->reg_mcoa?
+			get_bid_from_ifindex(event->iface->ifindex)
+			:MCOA_NO_BID)))
+		active_coa = mcoa_bule_count(bule);
+
+	if (event->event_type == ME_COA_EXPIRED &&
+	    IN6_ARE_ADDR_EQUAL(&event->coa->addr, &hai->hoa.addr))
+		return;
+
+	hai->current_coa = mcoa_get_current_coa(hai, event->iface->ifindex);
+	if (hai->current_coa == NULL)
+		return;
+
+	hai->verdict = mcoa_mn_make_ho_verdict(event, hai, &rtr, &coa);
+	MDBG2("Verdict %d for iface %d\n", 
+		hai->verdict, hai->current_coa->iif);
+
+	if (hai->verdict == MN_HO_IGNORE)
+		return;
+
+	if (hai->verdict == MN_HO_INVALIDATE) {
+		/* MCoA 
+		 * Unless this is the last available interface
+		 * Rules related to this iface are deleted, 
+		 * BULE is deleted, and deregistration BU is sent
+		 */
+		if (active_coa > 1 
+		    && (bule = mcoa_iface_rules_del(hai->current_coa->iif, 
+						    hai, 1)))
+			/* MCoA TODO2
+			 * Send a deregistration BU 
+			 * Is it the correct place to do that? 
+			 * because when BACK is received, BULE has 
+			 * already been deleted
+			 * (actually BAck cannot be received at the BULE's CoA
+			 * because the iface is down...)
+			 */
+			mn_dereg_bule(bule);
+		hai->current_coa = NULL;
+		return;
+	} 
+	if (rtr != NULL)
+		move_home = mn_home_rtr_chk(hai, rtr);
+
+	if  (hai->verdict == MN_HO_CHECK_LIFETIME) {
+		mn_update_coa_lifetime(hai->current_coa, coa);
+		mn_coa_updated(hai);
+	} else if (hai->verdict == MN_HO_REESTABLISH) {
+		mn_update_coa_lifetime(hai->current_coa, coa);
+		mn_coa_updated(hai);
+	} else { 
+		switch (hai->verdict) {
+		case MN_HO_PROCEED:
+			hai->current_coa->addr = coa->addr;
+			mn_update_coa_lifetime(hai->current_coa, coa);
+			/* MCoA
+			 * Rules related to this iface are added if needed
+			 */
+			mcoa_iface_rules_add(hai->current_coa->iif, hai);
+			break;
+		case MN_HO_RETURN_HOME:
+			hai->current_coa->addr = hai->hoa.addr;
+		        mcoa_iface_rules_del(hai->current_coa->iif, hai, 1);
+			break;
+		default:
+			return;
+		}
+		if (hai->at_home && !hai->pend_ba) {
+			/* check if router is HA */
+			if (hai->home_reg_status != HOME_REG_NONE &&
+			    rtr_addr_chk(rtr, &hai->ha_addr)) {
+				mn_move(hai);
+			} else if (hai->home_reg_status != HOME_REG_NONE ||
+				   move_home) {
+				int type = FLUSH_FAILED;
+				mn_do_dad(hai, 0);
+				if (hai->home_reg_status == HOME_REG_NONE)
+					bul_iterate(&hai->bul,
+						    _bul_flush, &type);
+			}
+		}
+	}
 }
 
 static void mn_chk_ho_verdict(struct home_addr_info *hai,
@@ -2244,35 +3117,36 @@ static void mn_chk_ho_verdict(struct hom
 	    IN6_ARE_ADDR_EQUAL(&event->coa->addr, &hai->hoa.addr))
 		return;
 
+	assert(hai->current_coa);
 	hai->verdict = mn_make_ho_verdict(event, hai, &rtr, &coa);
 
 	if (hai->verdict == MN_HO_IGNORE)
 		return;
 
 	if (hai->verdict == MN_HO_INVALIDATE) {
-		hai->primary_coa.iif = 0;
+		hai->current_coa->iif = 0;
 		return;
 	} 
 	if (rtr != NULL)
 		move_home = mn_home_rtr_chk(hai, rtr);
 
 	if (hai->verdict == MN_HO_CHECK_LIFETIME) {
-		mn_update_coa_lifetime(&hai->primary_coa, coa);
+		mn_update_coa_lifetime(hai->current_coa, coa);
 		mn_coa_updated(hai);
 	} else if (hai->verdict == MN_HO_REESTABLISH) {
-		hai->primary_coa.iif = coa->ifindex;
-		mn_update_coa_lifetime(&hai->primary_coa, coa);
+		hai->current_coa->iif = coa->ifindex;
+		mn_update_coa_lifetime(hai->current_coa, coa);
 		mn_coa_updated(hai);
 	} else { 
 		switch (hai->verdict) {
 		case MN_HO_PROCEED:
-			hai->primary_coa.iif = coa->ifindex;
-			hai->primary_coa.addr = coa->addr;
-			mn_update_coa_lifetime(&hai->primary_coa, coa);
+			hai->current_coa->iif = coa->ifindex;
+			hai->current_coa->addr = coa->addr;
+			mn_update_coa_lifetime(hai->current_coa, coa);
 			break;
 		case MN_HO_RETURN_HOME:
-			hai->primary_coa.iif = rtr->ifindex;
-			hai->primary_coa.addr = hai->hoa.addr;
+			hai->current_coa->iif = rtr->ifindex;
+			hai->current_coa->addr = hai->hoa.addr;
 			break;
 		default:
 			return;
@@ -2311,14 +3185,20 @@ int mn_movement_event(struct movement_ev
 				return 0;
 			}
 			dhaad_stop(hai);
-			mn_chk_ho_verdict(hai, event);
+			if (hai->reg_mcoa)
+				mcoa_mn_chk_ho_verdict(hai, event);
+			else	
+				mn_chk_ho_verdict(hai, event);
 		} else {
 			if (event->event_type == ME_COA_EXPIRED)
 				mn_rr_delete_co(&event->coa->addr);
 			list_for_each(lh, &home_addr_list) {
 				hai = list_entry(lh, 
 						 struct home_addr_info, list);
-				mn_chk_ho_verdict(hai, event);
+				if (hai->reg_mcoa)
+					mcoa_mn_chk_ho_verdict(hai, event);
+				else	
+					mn_chk_ho_verdict(hai, event);
 			}
 		}
 	}
@@ -2397,7 +3277,9 @@ void mn_start_ro(struct in6_addr *cn, st
 		     "from %x:%x:%x:%x:%x:%x:%x:%x\n", 
 		     NIP6ADDR(cn), NIP6ADDR(hoa));
 
-		bule = bul_get(NULL, hoa, cn);
+		bule = bul_get(NULL, hoa, cn, 
+			       hai->reg_mcoa?
+			       get_bid_from_ifindex(iif):MCOA_NO_BID);
 
 		if (bule) {
 			/* If BUL entry exists, RR is done or in progress */
@@ -2405,7 +3287,9 @@ void mn_start_ro(struct in6_addr *cn, st
 			return;
 		}
 
-		bule = create_bule(hoa, cn);
+		bule = create_bule(hoa, cn,
+				   hai->reg_mcoa?
+				   get_bid_from_ifindex(iif):MCOA_NO_BID);
 		if (!bule) {
 			MDBG("Malloc failed at starting of RO\n");
 			pthread_rwlock_unlock(&mn_lock);
@@ -2419,6 +3303,18 @@ void mn_start_ro(struct in6_addr *cn, st
 		bule->coa_changed = -1;
 		bule->home = hai;
 		bule->rr.state = RR_NOT_STARTED;
+		bule->priority = get_prio_from_bid(bule->bid);
+		/* MCoA TODO2
+		 * At the moment we prevent MIPL from installing rules for 
+		 * this entry
+		 */
+		bule->rules = 1;
+		/* MCoA TODO2
+		 * Support for CN
+		 * The table index must be filled with 
+		 * mcoa_mn_init_rt_table(bule)
+		 */
+		bule->table = RT6_TABLE_MIP6;
 
 		mn_reset_ro_bule(bule);
 
@@ -2451,7 +3347,10 @@ static void mn_recv_brr(const struct ip6
 	hoa = in->dst;
 	pthread_rwlock_wrlock(&mn_lock);
 	/* Do we have BUL entry for cn?  If not, drop. */
-	if ((e = bul_get(NULL, hoa, cn)) == NULL) {
+	/* MCoA TODO2
+	 * get BID from BRR BUI option
+	 */
+	if ((e = bul_get(NULL, hoa, cn, get_bid_from_ifindex(iif))) == NULL) {
 		pthread_rwlock_unlock(&mn_lock);
 		return;
 	}
@@ -2499,7 +3398,11 @@ static void mn_recv_be(const struct ip6_
 		hoa = in->dst;
 
 	/* Do we have BUL entry for cn?  If not, drop. */
-	if ((e = bul_get(NULL, hoa, cn)) == NULL || e->type != BUL_ENTRY)
+	/* MCoA TODO2
+	 * get BID from BUI option in BERROR
+	 */
+	if ((e = bul_get(NULL, hoa, cn, get_bid_from_ifindex(iif))) == NULL 
+	    || e->type != BUL_ENTRY)
 		goto out;
 
 	clock_gettime(CLOCK_REALTIME, &now);
